﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr253_1
{
    // Класс с целочисленным полем:
    class MyClass {
        // Целочисленное поле: 
        public int code;
        // Конструктор: 
        public MyClass(int n) { 
            code=n;
        }
                // Переопределение метода ToString(): 
        public override string ToString() { 
            return "поле = " + code;
        }
                // Операторный метод для преобразования объекта к 
        // целочисленному типу:
        public static implicit operator int(MyClass obj) { 
            return obj.code;
        }
        // Операторный метод для преобразования целого числа 
        // в объект:
        public static implicit operator MyClass(int n) { 
            return new MyClass(n);
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Обобщенный метод (с аргументом обобщенного типа): 
            static void show<T>(T arg) {
                // Обобщенный параметр:
                Console.WriteLine("Обобщенный параметр: {0}", typeof(T).Name);
                // Значение аргумента:
                Console.WriteLine("Значение аргумента: {0}", arg);
                Console.WriteLine("	");
            }
        // Главный метод: 
        static void Main() {
            // Вызов обобщенных методов:
            show(100);
            show<int>(200);
            show<double>(300);
            show<MyClass>(400);
            show('A');
            show<char>('B');
            show<int>('C');
            show("Alpha");
            MyClass obj = new MyClass(500); // Создание объекта
            show(obj);
            show<int>(obj);
            // Задержка:
            Console.ReadLine();
        }
    }
}
